/*
Copyright (c) 2006. The Regents of Columbia University, All Rights Reserved.
 
Permission to use, copy and distribute this software and its documentation 
for any purpose, without fee, and without a written agreement, is hereby granted, 
provided that the above copyright notice, this paragraph and the following two 
paragraphs appear in all copies and distributions.  

Created by Lulin Song, 
           International Research Institute Society,
           Columbia University

                       
REGENTS SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A  PARTICULAR PURPOSE. THE SOFTWARE AND ACCOMPANYING DOCUMENTATION,
IF ANY, PROVIDED HEREUNDER IS PROVIDED "AS IS". REGENTS HAS
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.
*/

#include "winExtra.h"
#include <iostream>

#ifdef WIN32
//double drand16()
//{
//  long int intermediate = rand(); //16 bits integer on Windows
//  return randomNumberGenerator(intermediate);
//}

void srand48( time_t x)
{
  srand(x); //seed the rand
}

void getWindowFileName( char* filename)
{
  /* remove " from file name */
  size_t len = strlen(filename);
  if(filename[0]=='\"')
    {
      for(size_t m=1;m<len-1;m++)
	{
	  filename[m-1]=filename[m];
	}
      filename[len-2]='\0';
    }
}

#endif

#if defined WIN32 || CYGWIN
double randomNumberGenerator(long int idum)
{
	int ix =-1;
	int iy=-1;
	int k;
	double am;

	if(idum <=0 || iy < 0)
	{
      am = 1.0/IM;
	  iy = (888889999^(abs(idum))) | 1;
	  ix = 777755555 ^ (abs(idum));
	  idum = abs(idum)+1;
	}
    ix = ix ^(ix<<13);
	ix = ix ^(ix>>17);
	ix = ix ^(ix<<5);
	k=iy/IQ;
	iy = IA *(iy-k*IQ)-IR*k;
	if( iy < 0 ) iy = iy +IM;
	double r =am *((IM &(ix^iy))|1);
//	printf("%64.16f\n",r);
	return am *((IM &(ix^iy))|1);  
}
#endif
